﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.ChartView;

namespace StackedBars_Dynamic_Demo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<ChartData> data1 = new ObservableCollection<ChartData>();

        public MainWindow()
        {
            InitializeComponent();
            data1.Add(new ChartData("Text 1", 25, 35, 45));
            data1.Add(new ChartData("Text 2", 5, 25, 45));
            data1.Add(new ChartData("Text 3", 15, 55, 65));
            data1.Add(new ChartData("Text 4", 55, 35, 55));
            data1.Add(new ChartData("Text 5", 35, 45, 65));
            data1.Add(new ChartData("Text 6", 75, 15, 25));
            data1.Add(new ChartData("Text 7", 45, 25, 35));

            CreateStackedBar();
        }

        private void CreateStackedBar()
        {
            BarSeries barSeries = new BarSeries();
            BarSeries barSeries2 = new BarSeries();
            BarSeries barSeries3 = new BarSeries();

            barSeries.CategoryBinding = new PropertyNameDataPointBinding() { PropertyName = "Title" };
            barSeries.ValueBinding = new GenericDataPointBinding<ChartData, double?>() { ValueSelector = selector => selector.Value1 };
            barSeries.ItemsSource = data1;
            barSeries.CombineMode = Telerik.Charting.ChartSeriesCombineMode.Stack;
            barSeries.StackGroupKey = "group1";

            barSeries2.CategoryBinding = new PropertyNameDataPointBinding() { PropertyName = "Title" };
            barSeries2.ValueBinding = new GenericDataPointBinding<ChartData, double?>() { ValueSelector = selector => selector.Value2 };
            barSeries2.ItemsSource = data1;
            barSeries2.CombineMode = Telerik.Charting.ChartSeriesCombineMode.Stack;
            barSeries2.StackGroupKey = "group1";

            barSeries3.CategoryBinding = new PropertyNameDataPointBinding() { PropertyName = "Title" };
            barSeries3.ValueBinding = new GenericDataPointBinding<ChartData, double?>() { ValueSelector = selector => selector.Value3 };
            barSeries3.ItemsSource = data1;
            barSeries3.CombineMode = Telerik.Charting.ChartSeriesCombineMode.Stack;
            barSeries3.StackGroupKey = "group2";

            RadChart1.HorizontalAxis = new CategoricalAxis();
            RadChart1.VerticalAxis = new LinearAxis();

            RadChart1.Series.Add(barSeries);
            RadChart1.Series.Add(barSeries2);
            RadChart1.Series.Add(barSeries3);
        }
    }

    public class ChartData
    {
        public ChartData(string title, double? value1, double? value2, double? value3)
        {
            this.Title = title;
            this.Value1 = value1;
            this.Value2 = value2;
            this.Value3 = value3;
        }

        public string Title { get; set; }
        public double? Value1 { get; set; }
        public double? Value2 { get; set; }
        public double? Value3 { get; set; }
    }
}
